#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Jan  2 15:21:23 2018

@author: boiboite
"""

"------------------- MARCHE ALÉATOIRE D'UN POINT M --------------------"
"------------------------- ALGORITHME DM1 -----------------------------"
"Comment déplacer aléatoirement un point M(x ; y) sur un quadrillage (0 ; n)x(0 ; n)"
"    et enregistrer ses déplacements ?"
"Je jette un pièce équilibrée. Si elle tombe sur pile je déplace M de 1 en x."
"Si elle tombe sur face je déplace M de 1 en y."
"Soit M(0 ; 0) la position de départ de M"
"Les positions successives de M sont enregistrées dans deux listes,"
"    une liste posiMX des valeurs successives de x,"
"    une liste posiMY des valeurs successives de y,"
from random import sample

"Création de la pièce et position initiale du point M"
"J'exécute les lignes 24 à 45 autant de fois que la valeur de n."
piece = ('pile', 'face')
posiMX = [0] ; posiMY = [0] ; n = 0

"Je lance la pièce et j'ajoute 1 au compteur du nombre de déplacements"
tirage = sample(piece, 1) ; n += 1

"Je code l'issue 'pile' par 1 et l'issue 'face' par 0"
issue = int(tirage[0] == 'pile')

"Si l'issue vaut 1 je déplace M de 1 en x en ajoutant 1 à la dernière valeur de x,"
if (issue == 1):
    nouvelleValeurX = posiMX[-1] + 1
    "Je positionne cette dernière valeur de x à la fin de la liste des valeurs de x"
    posiMX.append(nouvelleValeurX)
    "La nouvelle valeur de y, positionnée en fin de liste, est égale à l'ancienne"
    posiMY.append(posiMY[-1])
else:
    "Sinon c'est la dernière valeur de y que j'augmente de 1."
    nouvelleValeurY = posiMY[-1] + 1
    "Je positionne cette dernière valeur de y à la fin de la liste des valeurs de y"
    posiMY.append(nouvelleValeurY)
    "La nouvelle valeur de x, positionnée en fin de liste, est égale à l'ancienne"
    posiMX.append(posiMX[-1])

"La représentation graphique de la marche du point M"
"Après avoir exécuté n fois les lignes de commandes précédentes"
from matplotlib import pyplot as plt
plt.figure()
plt.plot([0, n], [0, n], ls = 'none')
plt.xticks(range(n + 1)) ; plt.yticks(range(n + 1))
plt.text(0.1, 0, 'DÉPART M', va = 'bottom', ha = 'left',
         color = 'blue', rotation = 45)
plt.plot(posiMX, posiMY, 'bo-')
plt.plot(posiMX[n], posiMY[n], marker = '*', markerfacecolor = 'red', markersize = 10)
plt.text(posiMX[n], posiMY[n], 'TERMINUS M', va = 'bottom', ha = 'left', color = 'green')
plt.title('MARCHE ALÉATOIRE DU POINT M')
plt.xlabel('Abscisses x')
plt.ylabel('Ordonnées y')
plt.grid()
plt.show()

"----------------------------------------------------------------------"
"UNE FONCTION CORRESPONDANT À L'ALGORITHME DM1"
def DM1(nbdep = 5):
    from random import sample
    from matplotlib import pyplot as plt













    plt.figure()
    plt.plot([0, n], [0, n], ls = 'none')
    plt.xticks(range(n + 1)) ;  plt.yticks(range(n + 1))
    plt.text(0.1, 0, 'DÉPART M', va = 'bottom', ha = 'left',
             color = 'blue', rotation = 45)
    plt.plot(posiMX, posiMY, 'bo-')
    plt.plot(posiMX[n], posiMY[n], marker = '*', markerfacecolor = 'red', markersize = 10)
    plt.text(posiMX[n], posiMY[n], 'TERMINUS M', va = 'bottom', ha = 'left', color = 'green')
    plt.title('MARCHE ALÉATOIRE DU POINT M')
    plt.xlabel('Abscisses x')
    plt.ylabel('Ordonnées y')
    plt.grid()
    plt.show()


"----------------------------------------------------------------------"
"----------- MARCHES ALÉATOIRES DU LOUP ET DE L'AGNEAU ----------------"
"-------------------- INDICATEUR DE RENCONTRE -------------------------"
"---------------------- ALGORITHME LA4 --------------------------------"
"Les n positions de l'agneau et du loup sont enregistrées, au fur et à mesure"
"    des tirages, dans des listes afin de pouvoir illustrer les déplacements"
"L'agneau démarre en (0 ; 0) et le loup en (n ; n) L'agneau joue le premier"
"Il y a au maximun n jets et le déplacement s'arrête lorsqu'il y a rencontre"
"    car on a à faire à un loup vorace qui dévore les agneaux"

from random import sample

"Nombre n de déplacements prévus sur un quadrillage (0 ; n)x(0 ; n)"
n = 4

"La pièce"
piece = ('pile', 'face')

"La marche"
"L'agneau démarre en (0 ; 0) et le loup en (n ; n)."
"L'indicatrice de rencontre est positionnée à 0."
posisAgnX = [0] ; posisAgnY = [0]
posisLoupX = [n] ; posisLoupY = [n]
rencontre = 0

"n Déplacements de l'agneau et du loup"
for i in range(0, n):
    "l'agneau jette une pièce"
    tirAgn = sample(piece, 1)
    "Si elle tombe sur 'pile' il se déplace de 1 en x sinon de 1 en y"
    depAgn = int(tirAgn[0] == 'pile')
    if (depAgn == 1):
        posisAgnX.append(posisAgnX[-1] + 1)
        posisAgnY.append(posisAgnY[-1])
    else:
        posisAgnY.append(posisAgnY[-1] + 1)
        posisAgnX.append(posisAgnX[-1])
    "le loup jette une pièce"
    tirLoup = sample(piece, 1)
    "Si elle tombe sur 'pile' il se déplace de -1 en x sinon de -1 en y"
    depLoup = int(tirLoup[0] == 'pile')
    if (depLoup == 1):
        posisLoupX.append(posisLoupX[-1] - 1)
        posisLoupY.append(posisLoupY[-1])
    else:
        posisLoupY.append(posisLoupY[-1] - 1)
        posisLoupX.append(posisLoupX[-1])
"Si les cordonnées du loup et de l'agneau sont égales c'est qu'il y a rencontre"
if ((posisAgnX[-1] == posisLoupX[-1]) & (posisAgnY[-1] == posisLoupY[-1])):
    rencontre = 1
    print('Rencontre en (', posisAgnX[-1], ";", posisAgnY[-1], ')')
else:
    print('Pas de rencontre')

"----------------------------------------------------------------------"   
"Graphique des chemins du loup et de l'agneau"
from matplotlib import pyplot as plt
plt.figure()
plt.plot([0, n], [0, n], ls = 'none')
plt.xticks(range(n + 1)) ; plt.yticks(range(n + 1))
plt.plot(posisAgnX, posisAgnY, 'bo-')
plt.plot(posisLoupX, posisLoupY, 'gx--')
plt.text(0.1, 0, 'DÉPART AGNEAU', va = 'bottom', ha = 'left',
         color = 'blue', rotation = 45)
plt.text(n - .1, n - .1, 'DÉPART LOUP', va = 'top', ha = 'right',
         color = 'green', rotation = 45)
if rencontre == 1:
    plt.plot(posisAgnX[n], posisAgnY[n], marker = '*',
             markerfacecolor = 'red', markersize = 10)
    plt.text(posisAgnX[n], posisAgnY[n] - .1, 'RENCONTRE',
             va = 'top', ha = 'center', color = 'red')
plt.grid()
plt.show()

"----------------------------------------------------------------------"
"UNE FONCTION CORRESPONDANT À L'ALGORITHME LA4"
def LA4(n = 5):
    from random import sample
    from matplotlib import pyplot as plt


























    plt.figure()
    plt.plot([0, n], [0, n], ls = 'none')
    plt.xticks(range(n + 1)) ;  plt.yticks(range(n + 1))
    plt.plot(posisAgnX, posisAgnY, 'bo-')
    plt.plot(posisLoupX, posisLoupY, 'gx--')
    plt.text(0.1, 0, 'DÉPART AGNEAU', va = 'bottom', ha = 'left',
             color = 'blue', rotation = 45)
    plt.text(n - .1, n - .1, 'DÉPART LOUP', va = 'top', ha = 'right',
             color = 'green', rotation = 45)
    if rencontre == 1:
        plt.plot(posisAgnX[n], posisAgnY[n], marker = '*',
                 markerfacecolor = 'red', markersize = 10)
        plt.text(posisAgnX[n], posisAgnY[n] - .1, 'RENCONTRE',
                 va = 'top', ha = 'center', color = 'red')
    plt.grid()
    plt.show()


"----------- ESTIMATION DE LA PROBABILITÉ DE RENCONTRE ----------------"
"----------------------------------------------------------------------"
"Je m'inspire de LA4 pour construire une fonction qui simule n déplacements"
"    cad une marche aléatoire,  et indique une éventuelle rencontre."
"Il n'est pas nécessaire de garder la trace de tous les déplacements,"
"    seule la position finale est nécessaire et suffisante"
"Je ne tire plus une pièce mais directement un entier parmi 0 ou 1 équiprobables"
"positAgn et positLoup prennent pour valeurs les coordonnées successives"
"    du loup et de l'agneau au cours de leur marche aléatoire"
"À la fin de la marche je teste l'égalité des coordonnées du loup et de l'agneau"
def marche(n = 5):
    from random import randint
    positAgnX = 0 ; positAgnY = 0
    positLoupX = n ; positLoupY = n
    rencontre = 0
    for i in range(n):
        tirAgn = randint(0, 1)
        if (tirAgn == 1):
            positAgnX += 1
        else:
            positAgnY += 1
        tirLoup = randint(0, 1)
        if (tirLoup == 1):
            positLoupX -= 1
        else:
            positLoupY -= 1
    if ((positAgnX == positLoupX) & (positAgnY == positLoupY)):
        rencontre = 1
    return(rencontre)

"J'utilise la fonction marche(...) dans nbsim simulations pour estimer"
"    la probabilité de rencontre"
def rencontre(n = 4, nbsim = 5000):
    rencontres = 0
    for i in range(nbsim):
        rencontres += marche(n)
    estimProba = round(rencontres / nbsim, 4)
    print('Une estimation de la probabilité de rencontre est :', estimProba)


"----------- CARTOGRAPHIE DES POINTS DE RENCONTRE ---------------------"
"------ ET LEUR DISTRIBUTION DES FRÉQUENCES DE RENCONTRE --------------"
"-------- LA3 UTILISE LA1 ET LA2 --------------------------------------"

"------------------------------- LA1 --------------------------------"
"utilise randint de random"
"Une fonction qui retourne les coordonnées du point de rencontre simulée"
"    et de l'indicateur de rencontre."
"Je ne tire plus de pièce, je simule directement 0 et 1 équiprobables."
"Les n tirages, les n coordonnées successives du loup et de l'agneau"
"    sont enregistrées dans des listes."
def LA1(n = 5):
    from random import randint
    tirAgn = [randint(0, 1) for i in range(n)]
    depAgnX = tirAgn
    depAgnY = [int(tirAgn[i] == 0) for i in range(n)]
    tirLoup = [randint(-1, 0) for i in range(n)]
    depLoupX = tirLoup
    depLoupY = [- int(tirLoup[i] == 0) for i in range(n)]
    posisAgnX = [0] ; posisAgnY = [0]
    posisLoupX = [n] ; posisLoupY = [n]
    for i in range (n):
        posisAgnX.append(posisAgnX[i] + depAgnX[i])
        posisAgnY.append(posisAgnY[i] + depAgnY[i])
        posisLoupX.append(posisLoupX[i] + depLoupX[i])
        posisLoupY.append(posisLoupY[i] + depLoupY[i])
    if ((posisAgnX[n] == posisLoupX[n]) & (posisAgnY[n] == posisLoupY[n])):
        rencontre = 1
        return (posisAgnX[n], posisAgnY[n], rencontre)
    else:
        return ()

"------------------------------- LA2 --------------------------------"
"Utilise LA1 et numpy"
"nbsim simulations du jeu. 1 jeu = n lancers d'une pièce sur un quadrillage (0;n)x(0;n)."
"Retourne un tableau (n+1)x(n+1) contenant les effectifs des rencontres"
"    et le nombre total de recontres."
def LA2(nbsim = 5000, n = 4):
    import numpy as np
    grille = np.zeros((n + 1, n + 1), dtype = int)
    rencontres = 0
    for i in range(nbsim):
        resulJeu = LA1(n)
        if len(resulJeu) != 0:
            rencontres += 1
            grille[resulJeu[0], resulJeu[1]] += 1
    return(grille, rencontres)

"------------------------------- LA3 --------------------------------"
"Utilise LA1, LA2, numpy et pyplot de matplotlib"
"Le programme simule nbsim marches, estimant la probabilité de rencontre"
"    et faisant le graphique des fréquences simulées des lieux de rencontre"
"Utilise LA1 et LA2, numpy, pyplot"
def LA3(nbsim = 5000, n = 4):
    import numpy as np
    from matplotlib import pyplot as plt
    resulSim = LA2(nbsim, n)
    x = resulSim[0] ; rencontres = resulSim[1]
    freqRenc = rencontres / nbsim
    MessageFreqRenc = 'Une estimation de la probabilité\nde rencontre est de ' + str(freqRenc)
    print(MessageFreqRenc)
    distribEffec = np.array([x[i, n - i] for i in range(n + 1)])
    distribFreq = distribEffec / nbsim
    distribRayon = distribEffec / max(distribEffec) * 50
    airedisques = np.pi * distribRayon**2
    couleurs = np.random.rand(n + 1)
    plt.figure()
    plt.scatter(np.arange(n + 1), n - np.arange(n + 1),
                s = airedisques, c = couleurs, alpha = .5)
    plt.xticks(range(n + 1)) ; plt.yticks(range(n + 1))
    for i in range(n + 1):
        plt.text(i, n - i, distribFreq[i])
    plt.text(-.5, 0, MessageFreqRenc, horizontalalignment = 'left',
             verticalalignment = 'center')
    plt.axis('equal')
    plt.title('Distribution des fréquences simulées\ndes points de rencontre')
    plt.xlabel('Abscisses des points de rencontre')
    plt.ylabel('Ordonnées des points de rencontre')
    plt.grid()
    plt.show()





